require "dependor"
require "dependor/shorty"

require_relative "audio_feed_manager/support/getter_setter_method"
require_relative "audio_feed_manager/support/hash_constructor"

require_relative "audio_feed_manager/error"
require_relative "audio_feed_manager/cli/command"

require_relative "audio_feed_manager/application"
require_relative "audio_feed_manager/audio_file"
require_relative "audio_feed_manager/audio_file_adder"
require_relative "audio_feed_manager/audio_file_repository"
require_relative "audio_feed_manager/config"
require_relative "audio_feed_manager/config_repository"
require_relative "audio_feed_manager/cli"
require_relative "audio_feed_manager/cli/arguments"
require_relative "audio_feed_manager/cli/arguments_parser"
require_relative "audio_feed_manager/cli/arguments_specification"
require_relative "audio_feed_manager/console"
require_relative "audio_feed_manager/directory_lister"
require_relative "audio_feed_manager/feed"
require_relative "audio_feed_manager/feed_items_repository"
require_relative "audio_feed_manager/feed_repository"
require_relative "audio_feed_manager/feed_syncer"
require_relative "audio_feed_manager/file_storage"
require_relative "audio_feed_manager/id3_tags"
require_relative "audio_feed_manager/new_model_creator"
require_relative "audio_feed_manager/rss_generator"
require_relative "audio_feed_manager/rss_repository"
require_relative "audio_feed_manager/s3_gateway"
require_relative "audio_feed_manager/secret_token_generator"
require_relative "audio_feed_manager/stop_application"
require_relative "audio_feed_manager/tags"
require_relative "audio_feed_manager/unique_id_generator"
require_relative "audio_feed_manager/url_maker"
require_relative "audio_feed_manager/version"

require_relative "audio_feed_manager/cli/add_audio_file"
require_relative "audio_feed_manager/cli/add_feed"
require_relative "audio_feed_manager/cli/initialize_project"
require_relative "audio_feed_manager/cli/list_feeds"
require_relative "audio_feed_manager/cli/show_feed"
require_relative "audio_feed_manager/cli/get_feed_url"
require_relative "audio_feed_manager/cli/update_feed_rss"
require_relative "audio_feed_manager/cli/publish"

require_relative "audio_feed_manager/cli/commands_list"

module AudioFeedManager
  def self.run(pwd: Dir.pwd, argv: ARGV, stdin: $stdin, stdout: $stdout, stderr: $stderr, exit: ->(code) { exit code })
    app = Application.new(directory: pwd, stdin: stdin, stdout: stdout, stderr: stderr)
    app.cli.run(argv)
  rescue StopApplication
    exit.call(1)
  end
end
