module AudioFeedManager
  class AudioFileAdder
    takes :id3_tags, :audio_file_repository, :feed_items_repository

    def call(feed, file_name, title: ->(){}, author: ->(){})
      tags = id3_tags.read(file_name)
      audio_file = AudioFile.new(title: tags.title || title.call,
                                 author: tags.artist || author.call)
      audio_file = audio_file_repository.add(audio_file, file_name)
      feed_items_repository.add(feed, audio_file)
      audio_file
    end
  end
end
