module AudioFeedManager
  class CLI
    takes :commands_list, :arguments_parser, :help, :console

    def run(argv)
      command, options = commands_list.get(argv)
      args = arguments_parser.parse(command.arguments, options)
      command.run(args.to_hash)
    rescue UnknownCommand => e
      console.fail(e)
      help.print_usage
      raise StopApplication
    rescue InvalidArguments => e
      console.fail(e)
      help.print_command_usage(command.name)
      raise StopApplication
    end
  end
end
