module AudioFeedManager
  class AddFeed < Command
    arguments do |s|
      s.name 'feeds add'
      s.description 'Creates a new feed with a given title'

      s.argument :title, required: true, description: "Title of the feed"
    end

    takes :feed_repository, :rss_generator, :console

    def run(title:)
      description = console.ask("Description", default: title)
      feed = Feed.new(title: title, description: description)
      feed = feed_repository.add(feed)
      rss_generator.generate(feed)
      console.info("Feed added. You may now refer to it as #{feed.id}.")
    end
  end
end
