require 'forwardable'

module AudioFeedManager
  class Command
    extend Forwardable

    def self.arguments
      yield(arguments_specification)
    end

    def self.arguments_specification
      @arguments_specification ||= ArgumentsSpecification.no_arguments
    end

    def arguments
      self.class.arguments_specification
    end

    def_delegators :arguments, :name, :description, :usage_line,
      :has_arguments?, :required_arguments, :optional_arguments, :varargs_arguments

    def run(arguments = {})
    end
  end
end
