module AudioFeedManager
  class GetFeedUrl < Command
    arguments do |s|
      s.name 'feeds get-url'
      s.description 'Get URL of the feed'

      s.argument :feed, required: true, description: "Identifier of the feed to print the URL for."
    end

    takes :console, :feed_repository, :url_maker

    def run(feed:)
      feed = feed_repository.fetch(feed)
      url = url_maker.feed_url(feed)
      console.info(url)
    rescue FeedNotFound => e
      console.die(e)
    end
  end
end
