module AudioFeedManager
  class ListFeeds < Command
    arguments do |s|
      s.name 'feeds list'
      s.description 'Lists the created feeds'
    end

    takes :feed_repository, :console

    def run(_ = {})
      feeds = feed_repository.list

      if feeds.empty?
        print_no_feeds_message
      else
        print_feeds(feeds)
      end
    end

    private

    def print_feeds(feeds)
      console.info("Feeds:")
      console.info("")

      console.info("#\tID\tTitle")
      feeds.each_with_index do |feed, idx|
        console.info("#{idx+1}.\t#{feed.id}\t#{feed.title}")
      end
    end

    def print_no_feeds_message
      console.info("No feeds yet. Add one using: afm feeds add 'some title'")
      console.info("")
      console.info("\tafm feeds add 'some title'")
    end
  end
end
