module AudioFeedManager
  class Publish < Command
    arguments do |s|
      s.name 'publish'
      s.description 'Publish the RSS and MP3 files to S3.'
    end

    takes :feed_syncer, :feed_repository, :console

    def run(_ = {})
      feeds = feed_repository.list
      feeds.each do |feed|
        console.info("Syncing #{feed.id}")
        feed_syncer.sync(feed) do |file|
          console.info("Uploading file #{file}")
        end
      end
      console.info("Done.")
    end
  end
end
