module AudioFeedManager
  class UpdateFeedRss < Command
    arguments do |s|
      s.name 'feeds update-rss'
      s.description "Regenerates the RSS .xml file for the given feed"

      s.argument :feed, required: true, description: "Identifier of the feed to regenerate RSS for."
    end

    takes :feed_repository, :rss_generator, :console

    def run(feed:)
      feed = feed_repository.fetch(feed)
      rss_generator.generate(feed)
    rescue FeedNotFound => e
      console.die(e)
    end
  end
end
