module AudioFeedManager
  class Console
    takes :stderr, :stdout, :stdin

    def info(*msg)
      stdout.puts(*msg)
    end

    def error(*msg)
      stderr.puts(*msg)
    end

    def fail(error)
      error(error.message)
    end

    def die(error)
      self.fail(error)
      raise StopApplication
    end

    def ask(label, default: "")
      stdout.print "#{label} [#{default}]: "
      result = stdin.gets.to_s.chomp
      result == "" ? default : result
    end
  end
end
