module AudioFeedManager
  class FeedItemsRepository
    takes :items_directory, :audio_file_repository

    def add(feed, audio_file)
      prepend_to_file(items_file(feed), audio_file.id)
    end

    def list(feed)
      file = items_file(feed)
      return [] unless File.exist?(file)
      ids = File.read(file).lines.map(&:chomp)
      ids.map{|id| audio_file_repository.fetch(id)}
    end

    private

    def items_file(feed)
      items_directory.join(feed.bare_id)
    end

    def prepend_to_file(file_name, id)
      contents = File.exist?(file_name) ? File.read(file_name) : ""
      File.open(file_name, "w") do |f|
        f.puts id
        f.print contents
      end
    end
  end
end
