module AudioFeedManager
  class FeedRepository
    takes :feeds_directory,
      :feeds_prefix,
      :storage,
      :directory_lister,
      :new_model_creator

    def add(feed)
      new_model_creator.create(feed, directory: feeds_directory, prefix: feeds_prefix)
    end

    def list
      names = directory_lister.list(feeds_directory)
      ids = names.map{|name| "#{feeds_prefix}/#{name}"}
      ids.map {|id| fetch(id)}
    end

    def fetch(id)
      attrs = storage.read(id)
      Feed.new(attrs)
    rescue FileNotFound
      raise FeedNotFound.for_id(id)
    end
  end

  class FeedNotFound < Error
    def self.for_id(id)
      new("Feed by ID #{id} not found!")
    end
  end
end
