module AudioFeedManager
  class FeedSyncer
    takes :s3_gateway, :feed_items_repository,
      :rss_files_prefix,
      :rss_files_directory,
      :data_files_prefix,
      :data_files_directory

    def sync(feed, &block)
      rss_file = rss_files_directory.join(feed.secret_token + ".xml")
      s3_gateway.sync("#{rss_files_prefix}/#{feed.secret_token}.xml", rss_file, &block)

      audio_files = feed_items_repository.list(feed)
      audio_files.each do |audio_file|
        data_file = data_files_directory.join(audio_file.secret_token + audio_file.extension)
        s3_gateway.sync("#{data_files_prefix}/#{audio_file.secret_token}#{audio_file.extension}", data_file, &block)
      end
    end
  end
end
