require 'yaml'

module AudioFeedManager
  class FileStorage
    takes :directory

    def store(file_name, data = {})
      File.write(directory.join(file_name), data.to_yaml)
    end

    def read(file_name)
      YAML.load_file(directory.join(file_name))
    rescue SystemCallError => e
      raise FileNotFound, e.message
    end
  end

  class FileNotFound < Error
  end
end
