module AudioFeedManager
  class UniqueIdGenerator
    takes :directory_lister

    def generate(name, directory)
      existing_ids = directory_lister.list(directory)
      base_id = name.downcase.gsub(/[\s\.,']/, '-').gsub(/[^a-z0-9\-]/, '')

      proposed_id = base_id
      idx = 1
      while existing_ids.include?(proposed_id)
        proposed_id = "#{base_id}-#{idx}"
        idx += 1
      end

      proposed_id
    end
  end
end
