module AudioFeedManager
  class UrlMaker
    takes :rss_files_prefix, :data_files_prefix, :s3_gateway

    def feed_url(feed)
      s3_gateway.url("#{rss_files_prefix}/#{feed.secret_token}.xml")
    end

    def audio_file_url(audio_file)
      s3_gateway.url("#{data_files_prefix}/#{audio_file.secret_token}#{audio_file.extension}")
    end
  end
end
